from wsgiref.util import setup_testing_defaults
from wsgiref.simple_server import make_server
import re
import traceback
import os


def toHTMLCCharacter(str_):
    str_ = str_.replace(' ', '&#160;')
    str_ = str_.replace('<', '&lt;')
    str_ = str_.replace('>', '&gt;')


    return str_

def app(environ, start_response):
    setup_testing_defaults(environ)
    PATH_INFO = environ["PATH_INFO"].encode('iso-8859-1').decode('utf8')
    if PATH_INFO == '/':
        PATH_INFO = "/index.html"
    Type = PATH_INFO.split('.')[-1]
    Content_Type_dict={'js':'text/javascript',
               'css':'text/css',
               'html':'text/html',
               'png':'image/png',
               'jpg':'image/jpeg',
               'gif':'image/gif',
               'ttf':'font/ttf',
               'ico':'',
               'svg': 'image/svg+xml',
               'woff':'application/font-woff'}
    try:
        Content_type = Content_Type_dict[Type]
    except KeyError:
        print('KeyError:Content_Type_dict[Type],Type:'+Type)
        Content_type = 'text/plain'
    headers = [('Content-type', Content_type)]
    byteType = ['jpg','png','gif','ttf', 'woff']
    try:
        if Type in byteType:
            with open(WORKSPACE+PATH_INFO, mode="rb") as f:
                start_response('200 OK', headers)
                return [f.read()]
        elif Type == 'ico':
            start_response('200 OK', headers)
            return [b'']
        else:
            with open(WORKSPACE+PATH_INFO, mode="r", encoding="utf-8") as f:

                html = ''
                str_ = f.read()
                k = re.findall(r'{{(.*?)}}', str_, re.S)
    ##            print(k)
                loc = locals()
                for i in k:
                    exec(i)
    ##                print(loc['html'])
                    str_ = re.sub(r'{{[\s\S]*?}}', repr(loc['html'])[1:-1], str_, count=1)
                start_response('200 OK', headers)
                return [str_.encode("utf-8")]
    except Exception:
        Error_html = '<body style="background-color:#FEFDEB"><h1>报错了~</h1>'
        traceback_str = ''
        traceback_str += traceback.format_exc()
        traceback_str = toHTMLCCharacter(traceback_str)
        for i in traceback_str.split('\n'):
            Error_html += '<p style="font-family:courier;color:blue;line-height:5px">'+ i + '</p>'
        Error_html += '</body>'
        start_response('404 Not Found', [('Content-type', 'text/html')])
        return [Error_html.encode('utf-8')]

def run(workspace, port=80):
      global WORKSPACE
      WORKSPACE = workspace
      with make_server('', port, app) as httpd:
            print("[pyhtmlweb]Serving on port %d..." % port)
            httpd.serve_forever()

if __name__ == "__main__":
    run(os.getcwd(), 80)
